﻿/**************************************************************************************************
* THE OMICRON PROJECT
*-------------------------------------------------------------------------------------------------
* Copyright 2010-2015             Electronic Visualization Laboratory, University of Illinois at Chicago
* Authors:                                                                                
* Arthur Nishimoto                anishimoto42@gmail.com
*-------------------------------------------------------------------------------------------------
* Copyright (c) 2010-2015, Electronic Visualization Laboratory, University of Illinois at Chicago
* All rights reserved.
* Redistribution and use in source and binary forms, with or without modification, are permitted
* provided that the following conditions are met:
*
* Redistributions of source code must retain the above copyright notice, this list of conditions
* and the following disclaimer. Redistributions in binary form must reproduce the above copyright
* notice, this list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
* FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*************************************************************************************************/
using UnityEngine;
using System.Collections;
using omicron;
using omicronConnector;

#if USING_GETREAL3D
public abstract class OmicronEventClient : getReal3D.MonoBehaviourWithRpc {
#else
public abstract class OmicronEventClient : MonoBehaviour {
#endif
    OmicronManager omicronManager;
    
    protected EventBase.ServiceType eventOptions = EventBase.ServiceType.ServiceTypeAny;

    bool flagForRemoval = false;

	// Use this for initialization
	public void Start () {
		InitOmicron ();
	}

	public void InitOmicron()
	{
        omicronManager = OmicronManager.GetOmicronManager();
		omicronManager.AddClient(this);
	}

	// Update is called once per frame
	void Update () {
	}

    public abstract void OnEvent(EventData e);

	public void SetFlaggedForRemoval()
	{
		flagForRemoval = true;
	}

	public bool IsFlaggedForRemoval()
	{
		return flagForRemoval;
	}

    public EventBase.ServiceType GetClientType()
    {
        return eventOptions;
    }
}
